'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});


// Boolean monoid under conjunction
var all = exports.all = {
  empty: function empty() {
    return true;
  },
  concat: function concat(x, y) {
    return x && y;
  }
};

// Boolean monoid under disjunction
var any = exports.any = {
  empty: function empty() {
    return false;
  },
  concat: function concat(x, y) {
    return x || y;
  }
};

// Monoid under addition
var sum = exports.sum = {
  empty: function empty() {
    return 0;
  },
  concat: function concat(x, y) {
    return x + y;
  }
};

// Monoid under multiplication
var product = exports.product = {
  empty: function empty() {
    return 1;
  },
  concat: function concat(x, y) {
    return x * y;
  }
};

var stringMonoid = exports.stringMonoid = {
  empty: function empty() {
    return '';
  },
  concat: function concat(x, y) {
    return x + y;
  }
};